//////////////////////////////////////////////////
//////////Action for the Playermovement///////////
//////////////////////////////////////////////////
///////Actions:///////////////////////////////////
//////////PlayerMovement							 	//
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2007////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////

//////////////////////////////////////
//The Players Attributes//////////////
//////////////////////////////////////
//KeyboardInput
int key_Move_Forewards = 17;
int key_Move_Backwards = 31;
int key_Move_Left = 30;
int key_Move_Right = 32;
int key_Move_Run = 42;
int key_Move_Jump = 16;

//Camera
int Pl_Cam_vertex = 1051;

//Movement
int Pl_HeadMovement_speed = 10;
int Pl_Run_AddFactor = 1;

//Attributes
int Pl_att_Strength = 20;
int Pl_att_Athletics = 20;


///////////////////////////////////////
//Some Static Values///////////////////
///////////////////////////////////////
#define Pl_Walk_Strength_fac 0.3
#define Pl_Walk_Athletics_fac 0.4


///////////////////////////////////////
//Some Skilldefinitions////////////////
///////////////////////////////////////
#define Pl_Turning_speed skill1
#define Pl_Floor_dist skill2

#define Pl_Input_X skill21
#define Pl_Input_Y skill22
#define Pl_Input_Z skill23

#define Pl_Move_X skill24
#define Pl_Move_Y skill25
#define Pl_Move_Z skill26


action PlayerMovement()
{
	player = my;
	
	set(my,FLAG1);
	c_setminmax(my);
	vec_add(my.max_x,vector(10,0,0));
	
	while (1)
	{
		//get the input
		my.Pl_Input_X = key_pressed(key_Move_Forewards)-key_pressed(key_Move_Backwards);
		my.Pl_Input_Y = key_pressed(key_Move_Left)-key_pressed(key_Move_Right);
		my.Pl_Input_Z = key_pressed(key_Move_Jump);
		
		//turn the camera depending on the mousemovement
		camera.pan = clamp(camera.pan-mouse_force.x*Pl_HeadMovement_speed*time_step,my.pan-80,my.pan+80);
		camera.tilt = clamp(camera.tilt+mouse_force.y*Pl_HeadMovement_speed*time_step,-90,80);
		
		//calculate turning speed
		my.Pl_Turning_speed = (camera.pan-my.pan)*0.1;
		
		//calculate the walkspeed
		my.Pl_Move_X = my.Pl_Input_X*time_step*(Pl_att_Strength*Pl_Walk_Strength_fac+Pl_att_Athletics*Pl_Walk_Athletics_fac);
		my.Pl_Move_Y = my.Pl_Input_Y*time_step*(Pl_att_Strength*Pl_Walk_Strength_fac+Pl_att_Athletics*Pl_Walk_Athletics_fac);
		
		//running
		my.Pl_Move_X = my.Pl_Move_X+key_pressed(key_Move_Run)*my.Pl_Move_X*Pl_Run_AddFactor;
		
		//gravity
		my.Pl_Floor_dist = c_trace(my.x,vector(my.x,my.y,my.z-1000),IGNORE_PASSABLE|IGNORE_PASSENTS|USE_BOX|IGNORE_ME);
		if(my.Pl_Floor_dist > 2)
		{
			my.Pl_Move_Z -= 1*time_step;
		}else
		{
			if(my.Pl_Floor_dist <= 0)
			{
				my.Pl_Move_Z = 3*time_step;
			}else
			{
				my.Pl_Move_Z = 0;
				
				//jumping
				my.Pl_Move_Z = my.Pl_Input_Z*3;
			}
		}
		
		//turn the player
		if(my.Pl_Input_X != 0)
		{
			c_rotate(me,vector(my.Pl_Turning_speed*abs(my.Pl_Move_X),0,0),GLIDE|IGNORE_PASSABLE|IGNORE_PASSENTS);
		}
		{
			c_rotate(me,vector(my.Pl_Turning_speed*time_step,0,0),GLIDE|IGNORE_PASSABLE|IGNORE_PASSENTS);
		}
		
		//move the player
		c_move(me,my.Pl_Move_X,nullvector,GLIDE|IGNORE_PASSABLE|IGNORE_PASSENTS);
		
		//update the cameras position
		vec_for_vertex(camera.x,me,Pl_Cam_vertex);
		
		wait(1);
	}
}