//////////////////////////////////////////////////
/////Materials and Functions for the Shaders//////
//////////////////////////////////////////////////
///////Materials://///////////////////////////////
//////////NormalMappingModel						 	//
//////////NormalDetailMappingModel					//
//////////ReliefMappingModel						 	//
//////////////////////////////////////////////////
///////Functions://///////////////////////////////
//////////Ent_SetMaterial							 	//
//////////////////////////////////////////////////
//////////////////////////////////////////////////
////24.12.2007////////////////by Nils Daumann/////
/////////////slindev.wordpress.com////////////////
//////////////////////////////////////////////////

MATERIAL* NormalMappingModel =
{
	ambient_red = 46;
	ambient_green = 32;
	ambient_blue = 32;
	
	flags = TANGENT;
	effect = "NM_Model.fx";
}

MATERIAL* NormalDetailMappingModel =
{
	ambient_red = 46;
	ambient_green = 32;
	ambient_blue = 32;
	
	flags = TANGENT;
	effect = "NMDetail_model.fx";
}

MATERIAL* ReliefMappingModel =
{
	ambient_red = 46;
	ambient_green = 32;
	ambient_blue = 32;
	
	flags = TANGENT;
	effect = "RM_Model.fx";
}


void Ent_SetMaterial(int MaterialType)
{
	my.skill41 = floatv(my.skill2);
	my.skill42 = floatv(my.skill3);
	my.skill43 = floatv((my.ambient+100)/100);
	
	switch(MaterialType)
	{
		case 0:
			break;
			
		case 1:
			my.material = NormalMappingModel;
			break;
			
		case 2:
			my.skill44 = floatv(my.skill4);
			my.material = NormalDetailMappingModel;
			break;
			
		case 3:
			my.skill44 = floatv(my.skill4*0.01);
			my.material = ReliefMappingModel;
			break;
			
		default:
			break;
	}
}